defmodule DrainCloudCoreWeb.AuthController do
  use DrainCloudCoreWeb, :controller
  alias DrainCloudCoreWeb.AuthController.RegisterRequest, as: Request



  def register(conn, _params) do
    req = Request.from_request(conn)
    :logger.warning(req)
    json(conn, req)
  end
end

defmodule DrainCloudCoreWeb.AuthController.RegisterRequest do
  @derive [Poison.Encoder, Jason.Encoder]
  defstruct login: "", password: ""

  alias DrainCloudCoreWeb.AuthController.RegisterRequest, as: RegisterRequest
  def from_request(conn) do
    res = Plug.Conn.read_body(conn)

    case res do
      {:error, _} -> raise "failed to read request body: #{:error}"
      {_, data, _} ->
        Poison.decode!(data, as: %RegisterRequest{})
      _ -> raise "failed to read request body. uexpected result: #{res}"
    end
  end
end
